UpgradeList = LibStub("AceAddon-3.0"):NewAddon("UpgradeList", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("UpgradeList")

local UPGRADELIST_VERSION = GetAddOnMetadata('UpgradeList', 'Version')

local LSM = LibStub("LibSharedMedia-3.0")
local DEBUGMODE = false

local function debugUL(message, flag)
	if flag then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFE08800Upgrade List DEBUG: |r " .. message)
	end
end

-- Register some media
LSM:Register("sound", "Dungeon Ready", [[Sound\Interface\levelup2.wav]])
LSM:Register("sound", "Level Up", [[Sound\Interface\LevelUp.wav]])
LSM:Register("sound", "Capture Flag", [[Sound\Interface\PVPFlagCapturedHordeMono.wav]])
LSM:Register("sound", "Horde Flag Taken", [[Sound\Interface\PVPFlagTakenHordeMono.wav]])
LSM:Register("sound", "Alliance Flag Taken", [[Sound\Interface\PVPFlagTakenMono.wav]])
LSM:Register("sound", "Ready?", [[Sound\Interface\ReadyCheck.wav]])
LSM:Register("sound", "Whip", [[Sound\Item\Weapons\Whip\BullWhipHit1.wav]])
LSM:Register("sound", "Puppy Bark", [[Sound\Emitters\Emitter_Dalaran_Petstore_Puppy_07.wav]])
LSM:Register("sound", "Squire Horn", [[Sound\Events\squire_horn_aa.wav]])
LSM:Register("sound", "Zelda-Heart Piece", [[Interface\Addons\UpgradeList\Sounds\LTTP_Get_HeartPiece.ogg]]) 
LSM:Register("sound", "Zelda-Item", [[Interface\Addons\UpgradeList\Sounds\LTTP_ItemFanfare_Stereo.ogg]]) 
LSM:Register("sound", "Zelda-Rupee", [[Interface\Addons\UpgradeList\Sounds\LTTP_Rupee1.ogg]]) 
LSM:Register("sound", "Zelda-Secret", [[Interface\Addons\UpgradeList\Sounds\LTTP_Secret.ogg]]) 

UpgradeListLDB = LibStub("LibDataBroker-1.1"):NewDataObject("UpgradeList", {
	type = "launcher",
	label = "Upgrade List",
	icon = "Interface\\Icons\\Achievement_BG_returnXflags_def_WSG",
})

function UpgradeListLDB.OnClick(self, button)
	if (button == "LeftButton") then
		UpgradeList:OpenUpgradeList()
	else
		InterfaceOptionsFrame_OpenToCategory(UpgradeList.optionsFrame)
	end
end

local icon = LibStub("LibDBIcon-1.0")

local defaults = { 
	char = {
		PrimarySpecList = {
			Head = {
				Row = { },
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SecondarySpecList = {
			Head = {
				Row = {	},
				Count = 1,
			},
			Neck = {
				Row = {	},
				Count = 1,
			},
			Shoulder = {
				Row = {	},
				Count = 1,
			},
			Back = {
				Row = {	},
				Count = 1,
			},
			Chest = {
				Row = {	},
				Count = 1,
			},
			Wrist = {
				Row = {	},
				Count = 1,
			},
			Hand = {
				Row = {	},
				Count = 1,
			},
			Waist = {
				Row = {	},
				Count = 1,
			},
			Leg = {
				Row = {	},
				Count = 1,
			},
			Foot = {
				Row = {	},
				Count = 1,
			},
			Ring = {
				Row = {	},
				Count = 1,
			},
			Trinket = {
				Row = {	},
				Count = 1,
			},
			Main = {
				Row = {	},
				Count = 1,
			},
			Off = {
				Row = {	},
				Count = 1,
			},
			Other = {
				Row = {	},
				Count = 1,
			},
		},
		SavedOptions = {
			tableUL = {},
		},
	},
	profile = {
		ignoreflags = {
			rings = false,
			trinkets = false,
		},
		minimap = {
			hide = false,
		},
		mainframe = {
			lock = false,
			scale = 1.0,
			showoptions = true,
		},
		messages = {
			potential = true,
			potentiallocation = "scrollwindow",
			acquired = true,
			acquiredlocation = "scrollwindow",
			scrollwindow = nil,
		},
		sound = {
			potential = true,
			potentialchoice = "None",
			acquired = true,
			acquiredchoice = "None",
		},
		autodelete = {
			enable = true,
			messages = true,
			messagelocation = "chatwindow",
		},
		potentialspec = {
			choice = 1,
		},
		acquiredspec = {
			choice = 1,
		},
		onehandweapon = {
			choice = 1,
		},
	},
}

local options = {
	name = "Upgrade List",
	handler = UpgradeList,
	type = 'group',
	args = {
		GeneralOptions = {
			name = _G["COMPACT_UNIT_FRAME_PROFILE_SUBTYPE_ALL"],
			type = 'group',
			order = 1,
			args = {
				lockframe = { --option is UpgradeList.db.profile.mainframe.lock
					type = "toggle",
					name = _G["LOCK"],
					desc = L["Lock the Upgrade List frame."],
					order = 1.1,
					get = function(info) return UpgradeList.db.profile.mainframe.lock end,
					set = function(info, value)
							UpgradeList.db.profile.mainframe.lock = not UpgradeList.db.profile.mainframe.lock
							if UpgradeList.db.profile.mainframe.lock then
								UpgradeList.db.UI.MainFrame:SetMovable(false)
								UpgradeList.db.UI.MainFrame:EnableMouse(false)
							else
								UpgradeList.db.UI.MainFrame:SetMovable(true)
								UpgradeList.db.UI.MainFrame:EnableMouse(true)
							end
						  end,
				},
				minimapbutton = { --option is UpgradeList.db.profile.minimap.hide
					type = "toggle",
					name = L["Hide Minimap Button"],
					order = 1.2,
					get = function(info) return UpgradeList.db.profile.minimap.hide end,
					set = function(info, value)
							UpgradeList.db.profile.minimap.hide = not UpgradeList.db.profile.minimap.hide
							if UpgradeList.db.profile.minimap.hide then
								icon:Hide("UpgradeListLDB")
							else
								icon:Show("UpgradeListLDB")
							end
						  end,
				},
				scale = { --option is UpgradeList.db.profile.mainframe.scale
					type = "range",
					name = _G["UI_SCALE"],
					min = 0.01,
					max = 2,
					bigStep = 0.01,
					isPercent = true,
					get = function(info) return UpgradeList.db.profile.mainframe.scale end,
					set = function(info, value)
							UpgradeList.db.UI.MainFrame:SetScale(value)
							UpgradeList.db.profile.mainframe.scale = value
						  end,
					order = 1.3,
					width = "full",
				},
				togglebutton = {
					type = "execute",
					name = L["Open Upgrade List"],
					order = 1.4,
					desc = L["This button will Open the Upgrade List addon."],
					func = "OpenUpgradeList",
				},
			},
		},
		DetectionOptions = {
			name = L["Detection Options"],
			type = 'group',
			order = 2,
			args = {
				alertmessagepotential = { --option is UpgradeList.db.profile.messages.potential
					name = L["Enable Messages"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to send you a message if an item on your list is detected."],
					order = 2.1,
					get = function(info) return UpgradeList.db.profile.messages.potential end,
					set = function(info, value) UpgradeList.db.profile.messages.potential = not UpgradeList.db.profile.messages.potential end,
				},
				alertmessagespotentialdropdown = { --option is UpgradeList.db.profile.messages.potentiallocation
					name = L["Message Location:"],
					type = "select",
					desc = L["Select where you would like Upgrade List to display messages about detected upgrades."],
					values = {	chatwindow = L["Chat Window"],
								scrollwindow = L["Message Window"],
							 },
					get = function(info) return UpgradeList.db.profile.messages.potentiallocation end,
					set = function(info, value) UpgradeList.db.profile.messages.potentiallocation = value end,
					style = "dropdown",
					order = 2.2,
					disabled = function()
								if UpgradeList.db.profile.messages.potential then
									return false
								else
									return true
								end
							   end,
				},
				alertsoundpotential = { --option is UpgradeList.db.profile.sound.potential
					name = _G["ENABLE_SOUND"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to play a sound if an item on your list is detected."],
					order = 2.3,
					get = function(info) return UpgradeList.db.profile.sound.potential end,
					set = function(info, value) UpgradeList.db.profile.sound.potential = not UpgradeList.db.profile.sound.potential end,
				},
				alertsoundpotentialdropdown = { --option is UpgradeList.db.profile.sound.potentialchoice
					name = _G["SOUND_LABEL"],
					type = "select",
					dialogControl = "LSM30_Sound",
					desc = L["Select the sound you want to play when an item on your list is detected."],
					values = AceGUIWidgetLSMlists.sound,
					get = function(info) return UpgradeList.db.profile.sound.potentialchoice end,
					set = function(info, value) UpgradeList.db.profile.sound.potentialchoice = value end,
					style = "dropdown",
					order = 2.4,
					disabled = function()
								if UpgradeList.db.profile.sound.potential then
									return false
								else
									return true
								end
							   end,
				},
				potentialspecdescription = {
					name = L["When an item is detected, if an item is on both the primary spec list and secondary spec list:"],
					order = 2.5,
					type = "description",
					width = "double",
					fontSize = "medium",
				},
				potentialspecchoicedropdown = {
					name = L["Select action:"],
					type = "select",
					desc = L["Select how you would like Upgrade List to handle items in both spec lists."],
					values = {	[1] = L["Assume detected item is for Primary Spec list"],
								[2] = L["Assume detected item is for Secondary Spec list"],
							 },
					get = function(info) return UpgradeList.db.profile.potentialspec.choice end,
					set = function(info, value) UpgradeList.db.profile.potentialspec.choice = value end,
					style = "radio",
					order = 2.6,
					width = "double",
				},
			},
		},
		AcquireOptions = {
			name = L["Acquisition Options"],
			type = 'group',
			order = 3,
			args = {
				alertmessageacquired = { --option is UpgradeList.db.profile.messages.acquired
					name = L["Enable Messages"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to send you a message if an item on your list is acquired."],
					order = 3.1,
					get = function(info) return UpgradeList.db.profile.messages.acquired end,
					set = function(info, value) UpgradeList.db.profile.messages.acquired = not UpgradeList.db.profile.messages.acquired end,
				},
				alertmessagesacquireddropdown = { --option is UpgradeList.db.profile.messages.acquiredlocation
					name = L["Message Location:"],
					type = "select",
					desc = L["Select where you would like Upgrade List to display messages about acquired upgrades."],
					values = {	chatwindow = L["Chat Window"],
								scrollwindow = L["Message Window"],
							 },
					get = function(info) return UpgradeList.db.profile.messages.acquiredlocation end,
					set = function(info, value) UpgradeList.db.profile.messages.acquiredlocation = value end,
					style = "dropdown",
					order = 3.2,
					disabled = function() if UpgradeList.db.profile.messages.acquired then return false else return true end end,
				},
				alertsoundacquired = { --option is UpgradeList.db.profile.sound.acquired
					name = _G["ENABLE_SOUND"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to play a sound if an item on your list is acquired."],
					order = 3.3,
					get = function(info) return UpgradeList.db.profile.sound.acquired end,
					set = function(info, value) UpgradeList.db.profile.sound.acquired = not UpgradeList.db.profile.sound.acquired end,
				},
				alertsoundacquireddropdown = { --option is UpgradeList.db.profile.sound.acquiredchoice
					name = _G["SOUND_LABEL"],
					type = "select",
					dialogControl = "LSM30_Sound",
					desc = L["Select the sound you want to play when an item on your list is acquired."],
					values = AceGUIWidgetLSMlists.sound,
					get = function(info) return UpgradeList.db.profile.sound.acquiredchoice end,
					set = function(info, value) UpgradeList.db.profile.sound.acquiredchoice = value end,
					style = "dropdown",
					order = 3.4,
					disabled = function() if UpgradeList.db.profile.sound.acquired then return false else return true end end,
				},
				acquiredspecdescription = {
					name = L["When an item is acquired, if an item is on both the primary spec list and secondary spec list:"],
					order = 3.5,
					type = "description",
					width = "double",
					fontSize = "medium",
				},
				acquiredspecchoicedropdown = {
					name = L["Select action:"],
					type = "select",
					desc = L["Select how you would like Upgrade List to handle items in both spec lists."],
					values = {	[1] = L["Assume acquired item is for Primary Spec list"],
								[2] = L["Assume acquired item is for Secondary Spec list"],
							 },
					get = function(info) return UpgradeList.db.profile.acquiredspec.choice end,
					set = function(info, value) UpgradeList.db.profile.acquiredspec.choice = value end,
					style = "radio",
					order = 3.6,
					width = "double",
				},
			},
		},
		AutoDeleteOptions = {
			name = L["Auto-Delete Options"],
			type = 'group',
			order = 4,
			args = {
				autodelete = { --option is UpgradeList.db.profile.autodelete.enable
					name = L["Enable Auto-Delete"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to auto-delete acquired items along with items of a lower priority (excluding items in the \"Other\" tab)."],
					order = 4.1,
					get = function(info) return UpgradeList.db.profile.autodelete.enable end,
					set = function(info, value) UpgradeList.db.profile.autodelete.enable = not UpgradeList.db.profile.autodelete.enable end,
					width = "full",
				},
				autodeletemessage = { --option is UpgradeList.db.profile.autodelete.messages
					name = L["Enable Messages"],
					type = "toggle",
					desc = L["Enable to allow Upgrade List to send you a message when it auto-deletes items from your list."],
					order = 4.2,
					get = function(info) return UpgradeList.db.profile.autodelete.messages end,
					set = function(info, value) UpgradeList.db.profile.autodelete.messages = not UpgradeList.db.profile.autodelete.messages end,
					disabled = function() if UpgradeList.db.profile.autodelete.enable then return false else return true end end,
				},
				autodeletemessagedropdown = { --option is UpgradeList.db.profile.autodelete.messagelocation
					name = L["Message Location:"],
					type = "select",
					desc = L["Select where you would like Upgrade List to display messages about auto-deletion."],
					values = {	chatwindow = L["Chat Window"],
								scrollwindow = L["Message Window"],
							 },
					get = function(info) return UpgradeList.db.profile.autodelete.messagelocation end,
					set = function(info, value) UpgradeList.db.profile.autodelete.messagelocation = value end,
					style = "dropdown",
					order = 4.3,
					disabled = function() if UpgradeList.db.profile.autodelete.enable and UpgradeList.db.profile.autodelete.messages then return false else return true end end,
				},
				ignorerings = {
					name = L["Ignore Rings"],
					type = "toggle",
					desc = L["Check this option to make Upgrade List ignore Rings when auto-deleting."],
					order = 4.4,
					get = function(info) return UpgradeList.db.profile.ignoreflags.rings end,
					set = function(info, value) UpgradeList.db.profile.ignoreflags.rings = not UpgradeList.db.profile.ignoreflags.rings end,
					disabled = function() if UpgradeList.db.profile.autodelete.enable then return false else return true end end,
				},
				ignoretrinkets = {
					name = L["Ignore Trinkets"],
					type = "toggle",
					desc = L["Check this option to make Upgrade List ignore Trinkets when auto-deleting."],
					order = 4.5,
					get = function(info) return UpgradeList.db.profile.ignoreflags.trinkets end,
					set = function(info, value) UpgradeList.db.profile.ignoreflags.trinkets = not UpgradeList.db.profile.ignoreflags.trinkets end,
					disabled = function() if UpgradeList.db.profile.autodelete.enable then return false else return true end end,
				},
				onehandweapondescription = {
					name = L["When you receive a 1-handed weapon, if it is on your Main Hand list and your Off Hand list:"],
					order = 4.6,
					type = "description",
					width = "double",
					fontSize = "medium",
				},
				onehandweaponchoicedropdown = {
					name = L["Select action:"],
					type = "select",
					desc = L["Select how you would like Upgrade List to handle 1-handed weapons in both main hand and off hand lists."],
					values = {	[1] = L["Assume acquired weapon is for Main Hand list"],
								[2] = L["Assume acquired weapon is for Off Hand list"],
								[3] = L["Do nothing"],
								[4] = L["Ask me which list the acquired weapon is for"],
							 },
					get = function(info) return UpgradeList.db.profile.onehandweapon.choice end,
					set = function(info, value) UpgradeList.db.profile.onehandweapon.choice = value end,
					style = "radio",
					order = 4.7,
					width = "double",
				},
			},
		},
		DatabaseOptions = {
			name = L["Database Options"],
			type = 'group',
			order = 5,
			args = {
				header1 = {
					type = "header",
					name = L["Database Options"],
					order = 5.1
				},
				deletebutton = { 
					type = "execute",
					name = L["Delete ALL Data"],
					order = 5.2,
					desc = L["Delete ALL DATA in all tabs in both specs?"],
					func = function() UpgradeList.db.char.PrimarySpecList = defaults.char.PrimarySpecList UpgradeList.db.char.SecondarySpecList = defaults.char.SecondarySpecList end,
					confirm = true,
					width = "double",
				},
				deleteprimaryspec = {
					type = "execute",
					name = L["Clear Primary Spec"],
					order = 5.3,
					desc = L["Delete ALL DATA in the primary spec?"],
					func = function() UpgradeList.db.char.PrimarySpecList = defaults.char.PrimarySpecList end,
					confirm = true,
				},
				deletesecondaryspec = {
					type = "execute",
					name = L["Clear Secondary Spec"],
					order = 5.4,
					desc = L["Delete ALL DATA in the secondary spec?"],
					func = function() UpgradeList.db.char.SecondarySpecList = defaults.char.SecondarySpecList end,
					confirm = true,
				},
				header2 = {
					type = "header",
					name = "Import Options",
					order = 5.5,
				},
				rawrimportbutton = { 
					type = "execute",
					name = "Import from Rawr",
					order = 5.6,
					desc = "Allows the user to import a Rawr file.",
					func = "RawrImport",
				},
			},
		},
		Help = {
			name = L["Help"],
			type = 'group',
			order = 6,
			args = {
				header1 = {
					type = "header",
					name = L["What Is Upgrade List?"],
					order = 6.1,
				},
				addondescription = {
					type = "description",
					name = L["Upgrade List allows players to store gear sorted by slot and listed in order of priority. This makes it much easier for a player to keep track of wanted items and where they drop. If an item on the player's list drops, Upgrade List informs the player that the item is an upgrade. If the player receives an item on his or her list, Upgrade List can automatically remove it and all items of a lower priority from the list. Upgrade List also has dual-spec support, allowing a player to keep two separate lists of gear simultaneously."],
					order = 6.11,
					fontSize = "medium",
				},
				header2 = {
					type = "header",
					name = L["How Do I Add An Item?"],
					order = 6.2,
				},
				addingdescription = {
					type = "description",
					name = L["To add an item, begin by opening Upgrade List's main window.  Below the window there are options to add, move, and delete items.  In the top-center input field, enter the item's item ID or copy an item link into the field.  If Upgrade List can automatically determine the item's drop location, the red \'X\' will change to a checkmark and the dropdown menu will indicate the location has been automatically set.  If you wish to change the drop location or Upgrade List couldn't automatically find the drop location, use the dropdown menu to select how the item can be obtained.  (Note: For item detection, Upgrade List does NOT use the drop location information.  It is there as a reminder for the player where the item can be obtained.)\n\nAfter setting the drop location, you can enter an optional note about the item in the note field.\n\nNext, select whether the item being added is for your character's primary spec or your secondary spec.  If your character only has one spec, the secondary spec option will be disabled.\n\nNext, you can optionally set where the item will be added to your list.  This is useful if you want to add an item within a currently existing list.  If left blank, the item will be added to the end of your list.\n\nFinally, click the \'Add Item\' button.  If there are no problems, Upgrade List will add the item to the appropriate list and display a message at the bottom of the window.  If there is a problem, Upgrade List will notify you at the bottom of the window, allowing you to make the necessary changes before clicking the \'Add Item\' button again.\n\nOnce the item is successfully added, it will be visible in the appropriate list."],
					order = 6.21,
					fontSize = "medium",
				},
				header3 = {
					type = "header",
					name = L["Where Do I Find An Item's ID Number?"],
					order = 6.3,
				},
				itemIDdescription = {
					type = "description",
					name = L["Every item in World of Warcraft has its own unique item ID.  There is more than one way to determine an item's ID.  To see an item's ID in-game, you would need to install an addon that will show an item's ID in its tooltip.\n\nAlternatively, there are 3rd party websites that make finding an item's ID easy.  For example, you can use www.wowhead.com to find an item's ID.  Begin by searching for your desired item in Wowhead's database.  Once you find the item, look at the webpage's URL.  (It should look like: www.wowhead.com/item=#####)   The #'s after the \'item=\' is that item's unique item ID number.  When adding an item to Upgrade List, if you use that number, Upgrade List will be able to recongize the item and add it to your list."],
					order = 6.31,
					fontSize = "medium",
				},
				header4 = {
					type = "header",
					name = L["How Do I Use An Item Link To Add An Item?"],
					order = 6.4,
				},
				itemLinkdescription = {
					type = "description",
					name = L["In addition to using item ID's to add items, Upgrade List can also use item links.  Item links are clickible links typically seen in your chat window that, when clicked, show a tooltip containing that item's information.  To paste an item link into Upgrade List's item input box, click in the input box so the cursor is blinking in the box.  Then shift-click the item you want to add to the box.  This will paste the item link into the box.  Then finish adding the item like normal.\n\nYou can use the dungeon journal or an addon like AtlasLoot to have a wide range of items to add using their item links."],
					order = 6.41,
					fontSize = "medium",
				},
				header5 = {
					type = "header",
					name = L["Can I Add Items a Faster Way?"],
					order = 6.5,
				},
				importdescription = {
					type = "description",
					name = L["Along with adding items through Upgrade List's UI, Upgrade List currently supports importing items from a 3rd party program known as Rawr.  (Rawr can be found here: http://rawr.codeplex.com)  Using Rawr's documentation, load the character you wish to import items for.\n\nAfter your character is loaded and the options are set, go to \'File > Export to Rawr Addon...\'.  In the window that appears, copy all of the generated code.\n\nIn World of Warcraft, make sure you're logged onto the character you loaded in Rawr.  Go to Upgrade List's options and choose \'Database Options > Import from Rawr\'.  In the window that opens, paste the generated code into the window.  (Note: This can lag your game for several minutes, depending on how many items you are copying and the speed of your computer.  If your game lags too long, you will be disconnected.  If you get disconnected, you are trying to copy too many items.  Go back into Rawr and adjust the item filters so that less items are displayed.)\n\nOnce your code appears in the window, select whether the items should be loaded into your primary spec list or secondary spec list.  When you are ready to import the items, click the import button.  The status of the import and any problems Upgrade List encounters will be shown in your chat window.  After the import completes, your items should be listed in your Upgrade List window.  (Note: Items are not saved until you log off.  If you disconnect before logging off, you will likely need to re-import your items.)"],
					order = 6.51,
					fontSize = "medium",
				},
			},
		},
	},
}

function UpgradeList:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("UpgradeListDB", defaults, "Default")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList", "Upgrade List")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("UpgradeList-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("UpgradeList-Profiles", "Profiles", "Upgrade List")
	icon:Register("UpgradeListLDB", UpgradeListLDB, self.db.profile.minimap)
	self:RegisterChatCommand("upgradelist", "ChatCommand")
	self:RegisterChatCommand("ul", "ChatCommand")
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")
end

function UpgradeList:RefreshConfig()
	self.db.profile = self.db.profile
	
	--Need to update visual components
	if self.db.profile.minimap.hide == true then
		icon:Hide("UpgradeListLDB")
	else
		icon:Show("UpgradeListLDB")
	end
	
	if self.db.profile.mainframe.lock == true then
		self.db.UI.MainFrame:SetMovable(false)
		self.db.UI.MainFrame:EnableMouse(false)
	else
		self.db.UI.MainFrame:SetMovable(true)
		self.db.UI.MainFrame:EnableMouse(true)
	end
	
	self.db.UI.MainFrame:SetScale(self.db.profile.mainframe.scale)
	
end

function UpgradeList:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(UpgradeList, "ul", "upgradelist", input)
	end
end

function UpgradeList:LoadConstants()
	self.db.ImportData = {}
	self.db.UI = {}
	self.db.Constants = {}
	self.db.Constants.WeaponAndArmorSubTypes = {
		Bows = "59320",
		Crossbows = "63532",
		Daggers = "63536",
		Guns = "60210",
		Fishing_Poles = "19970",
		Fist_Weapons = "63538",
		One_Handed_Axes = "59443",
		One_Handed_Maces = "59459",
		One_Handed_Swords = "63533",
		Polearms = "64810",
		Staves = "59525",
		Two_Handed_Axes = "59330",
		Two_Handed_Maces = "59492",
		Two_Handed_Swords = "61346",
		Wands = "59460",
		Miscellaneous = "5956",
		Cloth = "59349",
		Leather = "69579",
		Mail = "59504",
		Plate = "59316",
		Shields = "55069",
	}
	self.db.Constants.EquipLocationNumbers = {
		{"INVTYPE_HEAD", 1, "Head"},
		{"INVTYPE_NECK", 2, "Neck"},
		{"INVTYPE_SHOULDER", 3, "Shoulder"},
		{"INVTYPE_CLOAK", 4, "Back"},
		{"INVTYPE_CHEST", 5, "Chest"},
		{"INVTYPE_ROBE", 5, "Chest"},
		{"INVTYPE_WRIST", 6, "Wrist"},
		{"INVTYPE_HAND", 7, "Hand"},
		{"INVTYPE_WAIST", 8, "Waist"},
		{"INVTYPE_LEGS", 9, "Leg"},
		{"INVTYPE_FEET", 10, "Foot"},
		{"INVTYPE_FINGER", 11, "Ring"},
		{"INVTYPE_TRINKET", 12, "Trinket"},
		{"INVTYPE_WEAPONMAINHAND", 13, "Main"},
		{"INVTYPE_2HWEAPON", 13, "Main"},
		{"INVTYPE_WEAPONOFFHAND", 14, "Off"},
		{"INVTYPE_HOLDABLE", 14, "Off"},
		{"INVTYPE_SHIELD", 14, "Off"},
	}
	self.db.Constants.TabNames = {
		{1, "Head", _G["HEADSLOT"], -570, 6, 95, 94},
		{2, "Neck", _G["NECKSLOT"], -490, 6, 95, 94},
		{3, "Shoulder", _G["SHOULDERSLOT"], -410, 6, 95, 94},
		{4, "Back", _G["BACKSLOT"], -330, 6, 95, 94},
		{5, "Chest", _G["CHESTSLOT"], -250, 6, 95, 94},
		{6, "Wrist", _G["WRISTSLOT"], -170, 6, 95, 94},
		{7, "Hand", _G["HANDSSLOT"], -90, 6, 95, 94},
		{8, "Waist", _G["WAISTSLOT"], -10, 6, 95, 94},
		{9, "Leg", _G["LEGSSLOT"], 70, 6, 95, 94},
		{10, "Foot", _G["FEETSLOT"], 150, 6, 95, 94},
		{11, "Ring", _G["FINGER0SLOT"], 230, 6, 95, 94},
		{12, "Trinket", _G["TRINKET0SLOT"], 310, 6, 95, 94},
		{13, "Main", _G["MAINHANDSLOT"], 392, 6, 100, 90},
		{14, "Off", _G["SECONDARYHANDSLOT"], 477, 6, 100, 94},
		{15, "Other", _G["OTHER"], 560, 6, 95, 94},
	}
	self.db.Constants.EquippableItems = {
		DEATHKNIGHT = {"Cloth", "Leather", "Mail", "Plate", "One_Handed_Maces", "Two_Handed_Maces", "Polearms", "One_Handed_Swords", "Two_Handed_Swords", "One_Handed_Axes", "Two_Handed_Axes", "Fishing_Poles", "Miscellaneous"},
		DRUID = {"Cloth", "Leather", "Daggers", "Fist_Weapons", "One_Handed_Maces", "Polearms", "Staves", "Two_Handed_Maces", "Fishing_Poles", "Miscellaneous"},
		HUNTER = {"Cloth", "Leather", "Mail", "Guns", "Bows", "Crossbows", "Fist_Weapons", "One_Handed_Axes", "One_Handed_Swords", "Polearms", "Staves", "Two_Handed_Axes", "Two_Handed_Swords", "Fishing_Poles", "Miscellaneous"},
		MAGE = {"Cloth", "Staves", "Wands", "Daggers", "One_Handed_Swords", "Fishing_Poles", "Miscellaneous"},
		MONK = {"Cloth", "Leather", "Polearms", "Staves", "One_Handed_Axes", "One_Handed_Swords", "One_Handed_Maces", "Fist_Weapons", "Fishing_Poles", "Miscellaneous"},
		PALADIN = {"Cloth", "Leather", "Mail", "Plate", "Shields", "One_Handed_Maces", "Two_Handed_Maces", "Polearms", "One_Handed_Swords", "Two_Handed_Swords", "One_Handed_Axes", "Two_Handed_Axes", "Fishing_Poles", "Miscellaneous"},
		PRIEST = {"Cloth", "Staves", "Wands", "Daggers", "One_Handed_Maces", "Fishing_Poles", "Miscellaneous"},
		ROGUE = {"Cloth", "Leather", "Daggers", "Fist_Weapons", "One_Handed_Maces", "One_Handed_Axes", "One_Handed_Swords", "Fishing_Poles", "Miscellaneous"},
		SHAMAN = {"Cloth", "Leather", "Mail", "Shields", "Daggers", "Fist_Weapons", "One_Handed_Maces", "One_Handed_Axes", "Staves", "Two_Handed_Maces", "Two_Handed_Axes", "Fishing_Poles", "Miscellaneous"},
		WARLOCK = {"Cloth", "Staves", "Wands", "Daggers", "One_Handed_Swords", "Fishing_Poles", "Miscellaneous"},
		WARRIOR = {"Cloth", "Leather", "Mail", "Plate", "Shields", "Fist_Weapons", "One_Handed_Axes", "One_Handed_Maces", "One_Handed_Swords", "Polearms", "Staves", "Two_Handed_Axes", "Two_Handed_Maces", "Two_Handed_Swords", "Fishing_Poles", "Miscellaneous"},
	}
	self.db.Constants.localizedItemType = {}
	for itemType,itemNumber in pairs(self.db.Constants.WeaponAndArmorSubTypes) do
		_, _, _, _, _, _, self.db.Constants.localizedItemType[itemType] = GetItemInfo(tonumber(itemNumber))
	end
	UpgradeList:LoadDungeonJournalInfo()
end

function UpgradeList:LoadDungeonJournalInfo()
	--{Name of Dungeon, Tier Name(Classic, BC, etc.), difficulty, {Bosses in that dungeon}}
	self.db.Dungeons = {}
	self.db.Raids = {}

	for i = 1, EJ_GetNumTiers(), 1 do
		EJ_SelectTier(i)
		local instanceCount = 1
		repeat
			local instanceID, name = EJ_GetInstanceByIndex(instanceCount, false) --get dungeon's info
			if instanceID == nil then
				break
			end
			EJ_SelectInstance(instanceID)
			local tierName = EJ_GetTierInfo(i)
			for j = 1, 2 do --checking to see which difficulties for a particular dungeon exist
				EJ_SetDifficulty(j)
				local skipDifficulty = false
				if EJ_GetEncounterInfoByIndex(1) ~= nil then --it was successful in changing the difficulty to a particualar level for a particular instance, selected difficulty for selected instance exists
					local difficulty = ""
					if j == 1 then
						difficulty = _G["PLAYER_DIFFICULTY1"] --Normal
					elseif j == 2 then
						difficulty = _G["PLAYER_DIFFICULTY2"] --Heroic
					else
						print("Unexpected difficulty detected for dungeon: " .. name)
					end
					if tierName ~= EJ_GetTierInfo(1) and j == 1 then --check for possibility of previously introducted dungeon now having a heroic mode (Deadmines, Scarlet Monastery, etc.)
						for _, v in pairs(self.db.Dungeons) do
							if name == v[1] then
								skipDifficulty = true
							end
						end
					end
					if not skipDifficulty then
						local bosses = {}
						local bossCount = 1
						repeat
							local bossName = EJ_GetEncounterInfoByIndex(bossCount)
							table.insert(bosses, bossName)
							bossCount = bossCount + 1
						until EJ_GetEncounterInfoByIndex(bossCount) == nil
						table.insert(self.db.Dungeons, {name, tierName, difficulty, bosses})
						if tierName == EJ_GetTierInfo(1) then --workaround for classic dungeons showing as having a heroic version, even though they do not
							break
						end
					end
				end
			end
			instanceCount = instanceCount + 1
		until EJ_GetInstanceByIndex(instanceCount, false) == nil
		
		instanceCount = 1
		repeat
			local instanceID, name = EJ_GetInstanceByIndex(instanceCount, true) --get raid's info
			if instanceID == nil then
				break
			end
			EJ_SelectInstance(instanceID)
			local tierName = EJ_GetTierInfo(i)
			for j = 1, 5, 1 do --checking to see which difficulties for a particular raid exist
				EJ_SetDifficulty(j)
				if EJ_GetEncounterInfoByIndex(1) ~= nil then --a boss exists for the selected difficulty
					local difficulty = ""
					local skipDifficulty = false
					if j == 1 then
						difficulty = _G["PLAYER_DIFFICULTY1"] --Normal
					elseif j == 2 then
						difficulty = _G["PLAYER_DIFFICULTY2"] --Heroic
					elseif j == 5 then
						difficulty = _G["PLAYER_DIFFICULTY3"] --LFR
					elseif j == 3 or j == 4 then
						skipDifficulty = true --don't need difficulties 3 or 4 since they're the same as 1 and 2, just different raid sizes
					else
						print("Unexpected difficulty detected for raid: " .. name)
					end
					if not skipDifficulty then
						local bosses = {}
						local bossCount = 1
						repeat
							local bossName = EJ_GetEncounterInfoByIndex(bossCount)
							table.insert(bosses, bossName)
							bossCount = bossCount + 1
						until EJ_GetEncounterInfoByIndex(bossCount) == nil
						table.insert(self.db.Raids, {name, tierName, difficulty, bosses})
					end
				end
			end
			instanceCount = instanceCount + 1
		until EJ_GetInstanceByIndex(instanceCount, true) == nil
	end
end

function UpgradeList:LoadItemIntoCache(item)
	GetItemInfo(item:GetText())
end

function UpgradeList:RefreshWindow()
	if self.db.UI.ViewPrimaryCheck:GetChecked() then --If the primary checkbox is checked
		for i = 1, #self.db.Constants.TabNames, 1 do
			if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == i then
				self.db.char.SavedOptions.tableUL:SetData(self.db.char.PrimarySpecList[self.db.Constants.TabNames[i][2]].Row, true)
			end
		end
	else --The secondary checkbox is checked
		for i = 1, #self.db.Constants.TabNames, 1 do
			if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == i then
				self.db.char.SavedOptions.tableUL:SetData(self.db.char.SecondarySpecList[self.db.Constants.TabNames[i][2]].Row, true)
			end
		end
	end
	for i = 1, #self.db.Constants.TabNames, 1 do
		PanelTemplates_TabResize(self.db.UI.MainFrame.tabs[i], 0, self.db.Constants.TabNames[i][6], self.db.Constants.TabNames[i][7])
	end
end

function UpgradeList:OpenUpgradeList()
	if self.db.Constants.localizedItemType[Cloth] == nil then --Things need to be loaded from cache into a usable form
		for itemType,itemNumber in pairs(self.db.Constants.WeaponAndArmorSubTypes) do
			_, _, _, _, _, _, self.db.Constants.localizedItemType[itemType] = GetItemInfo(tonumber(itemNumber))
		end
		--UpgradeList:LoadTierTokenNames() --In the ItemLocations.lua in the TOKENS section
	end
	UpgradeList:StatusBarUpdate("Upgrade List v " .. UPGRADELIST_VERSION)
	self.db.UI.MainFrame:Show()
	if self.db.profile.mainframe.showoptions == false then
		self.db.UI.OptionsFrame:Hide()
	end
	UpgradeList:RefreshWindow()
end

function UpgradeList:ValidateItem()
	local itemName, itemLink = GetItemInfo(self.db.UI.ItemEntryBox:GetText()) 
	if itemName ~= nil then
		local _, _, _, _, itemID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		UpgradeList:CancelAllTimers()
		EJ_SetSearch(itemName)
		if EJ_GetNumSearchResults() == 0 then --no match in dungeon journal
			UpgradeList:UpdateIcon(false)
			UIDropDownMenu_SetText(ULLocationDropDown_Button, L["Location:"])
		else
			for i = 1, EJ_GetNumSearchResults(), 1 do
				local EJID, _, EJDifficulty, EJInstanceID, EJEncounterID = EJ_GetSearchResult(i)
				local _, _, _, _, EJItemID = EJ_GetLootInfo(EJID)
				if tostring(EJItemID) == tostring(itemID) then --match found
					UpgradeList:UpdateIcon(true)
					self.db.SelectedInstance = self.db.UI.InstanceID[EJInstanceID] or UpgradeList.db.UI.RaidID[EJInstanceID]
					self.db.SelectedBoss = self.db.UI.BossID[EJEncounterID] or UpgradeList.db.UI.RaidBossID[EJEncounterID]
					self.db.SelectedDifficulty = UpgradeList:DetermineDifficulty(EJDifficulty, EJInstanceID)
					UIDropDownMenu_SetText(ULLocationDropDown_Button, L["Location Auto-Set!"])
					break
				end
			end
		end
	end
end

function UpgradeList:EnterItemIntoDatabase(itemLink, itemLevel, itemEquipLoc, itemID)
	debugUL("Function: EnterItemIntoDatabase", DEBUGMODE)
	local AddToSpec
	local AddToSpecLong
	local priorityfieldnum = tonumber(self.db.UI.PriorityField:GetText())
	if priorityfieldnum ~= nil then
		priorityfieldnum = math.floor(priorityfieldnum)
	end
	if self.db.UI.PrimarySpecRadioButton:GetChecked() then
		AddToSpec = _G["PRIMARY"]
		AddToSpecLong = "PrimarySpecList"
	else
		AddToSpec = _G["SECONDARY"]
		AddToSpecLong = "SecondarySpecList"
	end
	if priorityfieldnum == nil and self.db.UI.PriorityField:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["Priority field must be a number."], "red")
		self.db.UI.PriorityField:HighlightText()
		return
	elseif self.db.SelectedInstance == nil then
		UpgradeList:StatusBarUpdate(L["You must select an item location."], "red")
		self.db.UI.ItemEntryBox:ClearFocus()
		self.db.UI.NoteEntryBox:ClearFocus()
		self.db.UI.PriorityField:ClearFocus()
		return
	end
	if itemEquipLoc ~= "" and itemEquipLoc ~= "INVTYPE_BAG" and itemEquipLoc ~= "INVTYPE_TABARD" and itemEquipLoc ~= "INVTYPE_BODY" then
		local _, englishClass = UnitClass("player")
		if englishClass == "WARRIOR" and itemEquipLoc == "INVTYPE_2HWEAPON" then --warriors can equip 2H weapons in their off-hand
			WeaponInput:Show()
			UpgradeList:DisableInput()
		else
			for i = 1, #self.db.Constants.EquipLocationNumbers, 1 do --each tab, not including "Other" tab, it & 1H weapons have to be handled a little differently
				if itemEquipLoc == self.db.Constants.EquipLocationNumbers[i][1] then --Equip Location matched
					if self.db.UI.PriorityField:GetText() == "" or priorityfieldnum > self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count then --Priority # entered was blank or bigger than the list of items
						self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count] = { self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count, itemLevel, itemLink, self.db.SelectedDifficulty, self.db.SelectedInstance, self.db.SelectedBoss, self.db.UI.NoteEntryBox:GetText(), itemID }
					elseif priorityfieldnum <= self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
						table.insert(self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, self.db.SelectedDifficulty, self.db.SelectedInstance, self.db.SelectedBoss, self.db.UI.NoteEntryBox:GetText(), itemID })
						for j = self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count, priorityfieldnum, -1 do
							self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[j][1] = j
						end
					end
					self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count = self.db.char[AddToSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count + 1
					UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your "] .. AddToSpec .. L[" Spec's "] .. self.db.Constants.EquipLocationNumbers[i][3] .. L[" tab."], "green")
					if (PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == self.db.Constants.EquipLocationNumbers[i][2]) then --If you're viewing the tab you're adding to
						UpgradeList:RefreshWindow()
					end
					self.db.SelectedInstance = nil
					self.db.SelectedBoss = nil
					self.db.SelectedDifficulty = nil
					self.db.UI.ItemEntryBox:SetText("")
					self.db.UI.ItemEntryBox:ClearFocus()
					self.db.UI.NoteEntryBox:SetText("")
					self.db.UI.NoteEntryBox:ClearFocus()
					self.db.UI.PriorityField:SetText("")
					self.db.UI.PriorityField:ClearFocus()
					UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
				end
			end
		end
		if itemEquipLoc == "INVTYPE_WEAPON" then
			WeaponInput:Show() --After checking that priority field is a number and an item location is selected, show the WeaponInput frame.
			UpgradeList:DisableInput()
		end
	else --Adding to Other tab.
		if self.db.UI.PriorityField:GetText() == "" or priorityfieldnum > self.db.char[AddToSpecLong].Other.Count then --Priority # entered was blank or bigger than the list of items
			self.db.char[AddToSpecLong].Other.Row[self.db.char[AddToSpecLong].Other.Count] = { self.db.char[AddToSpecLong].Other.Count, itemLevel, itemLink, self.db.SelectedDifficulty, self.db.SelectedInstance, self.db.SelectedBoss, self.db.UI.NoteEntryBox:GetText(), itemID }
		elseif priorityfieldnum <= self.db.char[AddToSpecLong].Other.Count and priorityfieldnum > 0 then --If the priority number is equal to or less than the list length and not zero
			table.insert(self.db.char[AddToSpecLong].Other.Row, priorityfieldnum, { priorityfieldnum, itemLevel, itemLink, self.db.SelectedDifficulty, self.db.SelectedInstance, self.db.SelectedBoss, self.db.UI.NoteEntryBox:GetText(), itemID })
			for i = self.db.char[AddToSpecLong].Other.Count, priorityfieldnum, -1 do
				self.db.char[AddToSpecLong].Other.Row[i][1] = i
			end
		end
		self.db.char[AddToSpecLong].Other.Count = self.db.char[AddToSpecLong].Other.Count + 1
		UpgradeList:StatusBarUpdate(L["Successfully added "] .. itemLink .. L[" to your "] .. AddToSpec .. L[" Spec's Other tab."], "green")
		if (PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == 16) then --If you're viewing the tab you're adding to
			UpgradeList:RefreshWindow()
		end
		self.db.SelectedInstance = nil
		self.db.SelectedBoss = nil
		self.db.SelectedDifficulty = nil
		self.db.UI.ItemEntryBox:SetText("")
		self.db.UI.ItemEntryBox:ClearFocus()
		self.db.UI.NoteEntryBox:SetText("")
		self.db.UI.NoteEntryBox:ClearFocus()
		self.db.UI.PriorityField:SetText("")
		self.db.UI.PriorityField:ClearFocus()
		UIDropDownMenu_SetText(ULLocationDropDown_Button, _G["LOCATION_COLON"])
	end
	UpgradeList:UpdateIcon(false)
end

function UpgradeList:ItemCanBeWorn(itemSubType, class)
	local equippableFlag = false
	for englishClass,equippable in pairs(self.db.Constants.EquippableItems) do
		if class == englishClass then
			for i = 1, #equippable, 1 do
				if itemSubType == self.db.Constants.localizedItemType[equippable[i]] then
					equippableFlag = true
				end
			end
		end
	end
	return equippableFlag
end

function UpgradeList:AddItem()
	local _, itemLink, _, itemLevel, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(self.db.UI.ItemEntryBox:GetText())
	local ID, Color, Ltype
	if itemEquipLoc ~= nil then
		_, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	end
	if itemEquipLoc == "" or itemEquipLoc == "INVTYPE_BAG" or itemEquipLoc == "INVTYPE_TABARD" or itemEqupLoc == "BODY" then --Non-equipable items
		UpgradeList:EnterItemIntoDatabase(itemLink, itemLevel, itemEquipLoc, ID)
	elseif itemEquipLoc == nil then
		UpgradeList:StatusBarUpdate(L["Invalid Item"], "red")
		self.db.UI.ItemEntryBox:HighlightText()
		self.db.UI.ItemEntryBox:SetFocus()
	else
		local _, englishClass = UnitClass("player")	
		if UpgradeList:ItemCanBeWorn(itemSubType, englishClass) then
			UpgradeList:EnterItemIntoDatabase(itemLink, itemLevel, itemEquipLoc, ID)
		else
			UpgradeList:StatusBarUpdate(L["Your character cannot equip "] .. itemLink, "red")
			self.db.UI.ItemEntryBox:HighlightText()
			self.db.UI.ItemEntryBox:SetFocus()
		end
	end
end

function UpgradeList:DeleteItem()
	local DeleteFromSpec
	local DeleteFromSpecLong
	local tempItemLink
	local deletefieldnum = tonumber(self.db.UI.DeletingSingle.field:GetText())
	if deletefieldnum ~= nil then
		deletefieldnum = math.floor(deletefieldnum)
	end
	if self.db.UI.ViewPrimaryCheck:GetChecked() then
		DeleteFromSpec = _G["PRIMARY"]
		DeleteFromSpecLong = "PrimarySpecList"
	else
		DeleteFromSpec = _G["SECONDARY"]
		DeleteFromSpecLong = "SecondarySpecList"
	end
	if deletefieldnum == nil and self.db.UI.DeletingSingle.field:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["Delete field must be a number."], "red")
		self.db.UI.DeletingSingle.field:HighlightText()
		self.db.UI.DeletingSingle.field:SetFocus()
	elseif deletefieldnum == nil then
		UpgradeList:StatusBarUpdate(L["Nothing entered in delete field."], "red")
		self.db.UI.DeletingSingle.field:HighlightText()
		self.db.UI.DeletingSingle.field:SetFocus()
	else
		for i = 1, #self.db.Constants.TabNames, 1 do
			if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == i then
				if deletefieldnum >= self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count or deletefieldnum == 0 then --Entered delete number isn't in the list
					UpgradeList:StatusBarUpdate(L["Delete field does not match an item in your "] .. DeleteFromSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "red")
					self.db.UI.DeletingSingle.field:HighlightText()
					self.db.UI.DeletingSingle.field:SetFocus()
				elseif deletefieldnum ~= self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count - 1 and deletefieldnum > 0 then --Entered delete number is NOT the last one in the list
					tempItemLink = self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row[deletefieldnum][3]
					table.remove(self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row, deletefieldnum)
					self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count = self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count - 1
					UpgradeList:StatusBarUpdate(L["Successfully deleted "] .. tempItemLink .. L[" from your "] .. DeleteFromSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "green")
					for j = self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row[deletefieldnum][1], self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count, 1 do
						self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row[j - 1][1] = j - 1
					end
					self.db.UI.DeletingSingle.field:SetText("")
					self.db.UI.DeletingSingle.field:ClearFocus()
					UpgradeList:RefreshWindow()
				elseif deletefieldnum > 0 then --Deleting the last item in the list
					tempItemLink = self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row[deletefieldnum][3]
					table.remove(self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Row, deletefieldnum)
					self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count = self.db.char[DeleteFromSpecLong][self.db.Constants.TabNames[i][2]].Count - 1
					UpgradeList:StatusBarUpdate(L["Successfully deleted "] .. tempItemLink .. L[" from your "] .. DeleteFromSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "green")
					self.db.UI.DeletingSingle.field:SetText("")
					self.db.UI.DeletingSingle.field:ClearFocus()
					UpgradeList:RefreshWindow()
				else --Entered delete number is invalid
					UpgradeList:StatusBarUpdate(deletefieldnum .. L[" is not a valid number for deletion."], "red")
					self.db.UI.DeletingSingle.field:HighlightText()
					self.db.UI.DeletingSingle.field:SetFocus()
				end
			end
		end
	end
end

function UpgradeList:MoveItem()
	debugUL("UpgradeList:MoveItem()", DEBUGMODE)
	local MoveSpec
	local MoveSpecLong
	local tempItemLink
	local fromfieldnum = tonumber(self.db.UI.Moving.fromfield:GetText())
	local tofieldnum = tonumber(self.db.UI.Moving.tofield:GetText())
	if fromfieldnum ~= nil and tofieldnum ~= nil then
		fromfieldnum = math.floor(fromfieldnum)
		tofieldnum = math.floor(tofieldnum)
	end
	if self.db.UI.ViewPrimaryCheck:GetChecked() then
		MoveSpec = _G["PRIMARY"]
		MoveSpecLong = "PrimarySpecList"
	else
		MoveSpec = _G["SECONDARY"]
		MoveSpecLong = "SecondarySpecList"
	end
	if fromfieldnum == nil and self.db.UI.Moving.fromfield:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["From field must be a number."], "red")
		self.db.UI.Moving.fromfield:HighlightText()
		self.db.UI.Moving.fromfield:SetFocus()
	elseif tofieldnum == nil and self.db.UI.Moving.tofield:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["To field must be a number."], "red")
		self.db.UI.Moving.tofield:HighlightText()
		self.db.UI.Moving.tofield:SetFocus()
	elseif fromfieldnum == nil then
		UpgradeList:StatusBarUpdate(L["Nothing entered in From field."], "red")
		self.db.UI.Moving.fromfield:HighlightText()
		self.db.UI.Moving.fromfield:SetFocus()
	elseif tofieldnum == nil then
		UpgradeList:StatusBarUpdate(L["Nothing entered in To field."], "red")
		self.db.UI.Moving.tofield:HighlightText()
		self.db.UI.Moving.tofield:SetFocus()
	else
		for i = 1, #self.db.Constants.TabNames, 1 do
			if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == i then
				if fromfieldnum >= self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Count or fromfieldnum == 0 then
					UpgradeList:StatusBarUpdate(L["From field does not match an item in your "] .. MoveSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "red")
					self.db.UI.Moving.fromfield:HighlightText()
					self.db.UI.Moving.fromfield:SetFocus()
				elseif tofieldnum >= self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Count or tofieldnum == 0 then
					UpgradeList:StatusBarUpdate(L["To field does not match an item in your "] .. MoveSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "red")
					self.db.UI.Moving.tofield:HighlightText()
					self.db.UI.Moving.tofield:SetFocus()
				elseif tofieldnum == fromfieldnum then
					UpgradeList:StatusBarUpdate(L["From field and To field match.  Cannot move any items."], "red")
					self.db.UI.Moving.tofield:HighlightText()
					self.db.UI.Moving.fromfield:HighlightText()
					self.db.UI.Moving.tofield:SetFocus()
				else
					tempItemLink = self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row[fromfieldnum][3]
					if fromfieldnum > tofieldnum then
						table.insert(self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, tofieldnum, self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row[fromfieldnum])
						table.remove(self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, fromfieldnum + 1)
						for j = 1, #self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, 1 do
							self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row[j][1] = j
						end
					else
						table.insert(self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, tofieldnum + 1, self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row[fromfieldnum])
						table.remove(self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, fromfieldnum)
						for j = 1, #self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row, 1 do
							self.db.char[MoveSpecLong][self.db.Constants.TabNames[i][2]].Row[j][1] = j
						end
					end
					UpgradeList:StatusBarUpdate(L["Successfully moved "] .. tempItemLink .. L[" to position "] .. tofieldnum .. L[" in your "] .. MoveSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "green")
					self.db.UI.Moving.fromfield:SetText("")
					self.db.UI.Moving.fromfield:ClearFocus()
					self.db.UI.Moving.tofield:SetText("")
					self.db.UI.Moving.tofield:ClearFocus()
					UpgradeList:RefreshWindow()
				end
			end
		end
	end
end

function UpgradeList:DeleteSectionOfItems()
	debugUL("Function UpgradeList:DeleteSectionOfItems()", DEBUGMODE)
	local DeleteSectionSpec
	local DeleteSectionSpecLong
	local fromfieldnum = tonumber(self.db.UI.DeletingMultiple.multifromfield:GetText())
	local tofieldnum = tonumber(self.db.UI.DeletingMultiple.multitofield:GetText())
	if fromfieldnum ~= nil and tofieldnum ~= nil then
		fromfieldnum = math.floor(fromfieldnum)
		tofieldnum = math.floor(tofieldnum)
	end
	if self.db.UI.ViewPrimaryCheck:GetChecked() then
		DeleteSectionSpec = _G["PRIMARY"]
		DeleteSectionSpecLong = "PrimarySpecList"
	else
		DeleteSectionSpec = _G["SECONDARY"]
		DeleteSectionSpecLong = "SecondarySpecList"
	end
	if fromfieldnum == nil and self.db.UI.DeletingMultiple.multifromfield:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["From field must be a number."], "red")
		self.db.UI.DeletingMultiple.multifromfield:HighlightText()
		self.db.UI.DeletingMultiple.multifromfield:SetFocus()
	elseif tofieldnum == nil and self.db.UI.DeletingMultiple.multitofield:GetText() ~= "" then
		UpgradeList:StatusBarUpdate(L["To field must be a number."], "red")
		self.db.UI.DeletingMultiple.multitofield:HighlightText()
		self.db.UI.DeletingMultiple.multitofield:SetFocus()
	elseif fromfieldnum == nil then
		UpgradeList:StatusBarUpdate(L["Nothing entered in From field."], "red")
		self.db.UI.DeletingMultiple.multifromfield:HighlightText()
		self.db.UI.DeletingMultiple.multifromfield:SetFocus()
	elseif tofieldnum == nil then
		UpgradeList:StatusBarUpdate(L["Nothing entered in To field."], "red")
		self.db.UI.DeletingMultiple.multitofield:HighlightText()
		self.db.UI.DeletingMultiple.multitofield:SetFocus()
	else
		for i = 1, #self.db.Constants.TabNames, 1 do
			if PanelTemplates_GetSelectedTab(self.db.UI.MainFrame) == i then
				if fromfieldnum <= 0 or fromfieldnum >= self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Count then
					UpgradeList:StatusBarUpdate(L["From field does not match an item in your "] .. DeleteSectionSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "red")
					self.db.UI.DeletingMultiple.multifromfield:HighlightText()
					self.db.UI.DeletingMultiple.multifromfield:SetFocus()
				elseif tofieldnum <= 0 or tofieldnum >= self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Count then
					UpgradeList:StatusBarUpdate(L["To field does not match an item in your "] .. DeleteSectionSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "red")
					self.db.UI.DeletingMultiple.multitofield:HighlightText()
					self.db.UI.DeletingMultiple.multitofield:SetFocus()
				elseif tofieldnum == fromfieldnum then
					UpgradeList:StatusBarUpdate(L["You must use the Delete Item button and field above to delete only 1 item."], "red")
					deletefield:SetFocus()
				else
					if fromfieldnum > tofieldnum then
						local temp1 = tofieldnum
						tofieldnum = fromfieldnum
						fromfieldnum = temp1
					end
					for j = 1, (tofieldnum - fromfieldnum) + 1, 1 do
						table.remove(self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Row, fromfieldnum)
						self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Count = self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Count - 1
						for k = 1, #self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Row, 1 do
							self.db.char[DeleteSectionSpecLong][self.db.Constants.TabNames[i][2]].Row[k][1] = k
						end
					end
					UpgradeList:StatusBarUpdate(L["Successfully deleted all item from position "] .. fromfieldnum .. L[" through position "] .. tofieldnum .. L[" in your "] .. DeleteSectionSpec .. L[" Spec's "] .. self.db.Constants.TabNames[i][3] .. L[" list."], "green")
					self.db.UI.DeletingMultiple.multifromfield:SetText("")
					self.db.UI.DeletingMultiple.multifromfield:ClearFocus()
					self.db.UI.DeletingMultiple.multitofield:SetText("")
					self.db.UI.DeletingMultiple.multitofield:ClearFocus()
					UpgradeList:RefreshWindow()
				end
			end
		end
	end
end

function UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, onehandweaponslot) --spec can be "mainspec" or "offspec" | onehandweaponslot can be "mainhand" or "offhand"
	debugUL("Function UpgradeList:RemoveMultipleItems()", DEBUGMODE)
	local RemoveMultipleItemsSpec
	local RemoveMultipleItemsSpecLong
	if spec == "mainspec" then
		RemoveMultipleItemsSpec = _G["PRIMARY"]
		RemoveMultipleItemsSpecLong = "PrimarySpecList"
	else
		RemoveMultipleItemsSpec = _G["SECONDARY"]
		RemoveMultipleItemsSpecLong = "SecondarySpecList"
	end
	for i = 1, #self.db.Constants.EquipLocationNumbers, 1 do
		if itemEquipLocation == self.db.Constants.EquipLocationNumbers[i][1] then
			local rownum = 0
			repeat
				rownum = rownum + 1
			until (self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[rownum][8] == itemID or self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[rownum] == nil)
			if self.db.profile.autodelete.messages then
				if self.db.profile.autodelete.messagelocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				elseif self.db.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				end
			end
			for j = #self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row, rownum, -1 do
				table.remove(self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Row)
				self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count = self.db.char[RemoveMultipleItemsSpecLong][self.db.Constants.EquipLocationNumbers[i][3]].Count - 1
			end
		end
	end
	if itemEquipLocation == "INVTYPE_WEAPON" then
		local rownum = 0
		if onehandweaponslot == "mainhand" then
			repeat
				rownum = rownum + 1
			until (self.db.char[RemoveMultipleItemsSpecLong].Main.Row[rownum][8] == itemID or self.db.char[RemoveMultipleItemsSpecLong].Main.Row[rownum] == nil)
			if self.db.profile.autodelete.messages then
				if self.db.profile.autodelete.messagelocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong].Main.Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				elseif self.db.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong].Main.Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				end
			end
			for i = #self.db.char[RemoveMultipleItemsSpecLong].Main.Row, rownum, -1 do
				table.remove(self.db.char[RemoveMultipleItemsSpecLong].Main.Row)
				self.db.char[RemoveMultipleItemsSpecLong].Main.Count = self.db.char[RemoveMultipleItemsSpecLong].Main.Count - 1
			end
		else
			repeat
				rownum = rownum + 1
			until (self.db.char[RemoveMultipleItemsSpecLong].Off.Row[rownum][8] == itemID or self.db.char[RemoveMultipleItemsSpecLong].Off.Row[rownum] == nil)
			if self.db.profile.autodelete.messages then
				if self.db.profile.autodelete.messagelocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong].Off.Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				elseif self.db.profile.autodelete.messagelocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Auto-deleting "] .. self.db.char[RemoveMultipleItemsSpecLong].Off.Row[rownum][3] .. L[" from your "] .. RemoveMultipleItemsSpec .. L[" Spec's list."])
				end
			end
			for i = #self.db.char[RemoveMultipleItemsSpecLong].Off.Row, rownum, -1 do
				table.remove(self.db.char[RemoveMultipleItemsSpecLong].Off.Row)
				self.db.char[RemoveMultipleItemsSpecLong].Off.Count = self.db.char[RemoveMultipleItemsSpecLong].Off.Count - 1
			end
		end
	end
end

function UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, spec)
	self.db.UI.WeaponInput:Show()
	self.db.UI.WeaponInput.OK:SetScript("OnClick", function (self, button, down)
		if UpgradeList.db.UI.WeaponInput.MainHandCheck:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "mainhand")
		elseif UpgradeList.db.UI.WeaponInput.OffHandCheck:GetChecked() then
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, spec, "offhand")
		end
		self.db.UI.WeaponInput:Hide()
		self.db.UI.WeaponInput.OffHandCheck:SetChecked(false)
		self.db.UI.WeaponInput.MainHandCheck:SetChecked(true)
		UpgradeList:EnableInput()
	end)
end
--[[
function UpgradeList:DecideSpec(itemID, itemEquipLocation, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	self.db.UI.SpecInput:Show()
	self.db.UI.SpecInput.OK:SetScript("OnClick", function (self, button, down)
		if UpgradeList.db.UI.MainSpecCheck:GetChecked() then
			if weaponinmainprimary == true and weaponinoffprimary == true then
				self.db.UI.SpecInput:Hide()
				UpgradeList:DecideMainorOffHand(itemID, itemEqiupLocation, "mainspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil)
			end
		elseif UpgradeList.db.UI.OffSpecCheck:GetChecked() then
			if weaponinmainsecondary == true and weaponinoffsecondary == true then
				self.db.UI.SpecInput:Hide()
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "offspec")
			else
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil)
			end
		end
		self.db.UI.SpecInput:Hide()
		self.db.UI.OffSpecCheck:SetChecked(false)
		self.db.UI.MainSpecCheck:SetChecked(true)
		UpgradeList:EnableInput()
	end)
end
--]]
function UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
	debugUL("Function UpgradeList:AutoDelete()", DEBUGMODE)
	if primaryspecflag == true then --if acquired item was in main spec list only
		--Delete the item and those below it from the main spec list
		if weaponinmainprimary == true and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list and Off Hand list
			if self.db.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand")
			elseif self.db.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand")
			elseif self.db.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "mainspec")
			else
				return
			end
		elseif weaponinmainprimary == true and weaponinoffprimary == false then --if the acquired item is a 1-handed weapon in the primary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "mainhand")
		elseif weaponinmainprimary == false and weaponinoffprimary == true then --if the acquired item is a 1-handed weapon in the primary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", "offhand")
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "mainspec", nil) --Not a 1-handed weapon in main spec
		end
	else -- if acquired item was in off spec list only
		--Delete the item and those below it from the off spec list
		if weaponinmainsecondary == true and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list and Off Hand list
			if self.db.profile.onehandweapon.choice == 1 then --Consider the weapon as in the Main Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand")
			elseif self.db.profile.onehandweapon.choice == 2 then --Consider the weapon as in the Off Hand list
				UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand")
			elseif self.db.profile.onehandweapon.choice == 4 then --Ask the user which list the weapon is in
				UpgradeList:DecideMainorOffHand(itemID, itemEquipLocation, "offspec")
			else
				return
			end
		elseif weaponinmainsecondary == true and weaponinoffsecondary == false then --if the acquired item is a 1-handed weapon in the secondary spec's Main Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "mainhand")
		elseif weaponinmainsecondary == false and weaponinoffsecondary == true then --if the acquired item is a 1-handed weapon in the secondary spec's Off Hand list only
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", "offhand")
		else
			UpgradeList:RemoveMultipleItems(itemID, itemEquipLocation, "offspec", nil) --Not a 1-handed weapon in off spec
		end
	end
end

function UpgradeList:Compare(itemID, itemEquipLocation, attainability)
	local primaryspecflag = false
	local secondaryspecflag = false
	local weaponinmainprimary = false
	local weaponinoffprimary = false
	local weaponinmainsecondary = false
	local weaponinoffsecondary = false
	local otherflag = false
	local _, itemLink = GetItemInfo(itemID)
	
	debugUL("Function UpgradeList:Compare()", DEBUGMODE)
	if DEBUGMODE then print(itemID) end
	if DEBUGMODE then print(itemEquipLocation) end
	if DEBUGMODE then print(attainability) end
	
	local _, englishClass = UnitClass("player")
	
	if englishClass == "WARRIOR" and itemEquipLocation == "INVTYPE_2HWEAPON" then
		if self.db.char.PrimarySpecList.Main.Count > 1 then
			local i = 0
			repeat
				i = i + 1
				if itemID == self.db.char.PrimarySpecList.Main.Row[i][8] then
					primaryspecflag = true
					weaponinmainprimary = true
				end
			until (itemID == self.db.char.PrimarySpecList.Main.Row[i][8] or i == #self.db.char.PrimarySpecList.Main.Row)
		end
		if self.db.char.PrimarySpecList.Off.Count > 1 then
			local i = 0
			repeat
				i = i + 1
				if itemID == self.db.char.PrimarySpecList.Off.Row[i][8] then
					primaryspecflag = true
					weaponinoffprimary = true
				end
			until (itemID == self.db.char.PrimarySpecList.Off.Row[i][8] or i == #self.db.char.PrimarySpecList.Off.Row)
		end
	else
		for i = 1, #self.db.Constants.EquipLocationNumbers, 1 do --Primary Spec Equippable Items Except INVTYPE_WEAPON, INVTYPE_BAG, INVTYPE_TABARD, and INVTYPE_BODY
			if itemEquipLocation == self.db.Constants.EquipLocationNumbers[i][1] then
				if self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Count > 1 then
					local j = 0
					repeat
						j = j + 1
						if itemID == self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] then
							primaryspecflag = true
						end
					until (itemID == self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] or j == #self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row)
				end
			end
		end
		if itemEquipLocation == "INVTYPE_WEAPON" then --Primary Spec INVTYPE_WEAPON
			if self.db.char.PrimarySpecList.Main.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.PrimarySpecList.Main.Row[i][8] then
						primaryspecflag = true
						weaponinmainprimary = true
					end
				until (itemID == self.db.char.PrimarySpecList.Main.Row[i][8] or i == #self.db.char.PrimarySpecList.Main.Row)
			end
			if self.db.char.PrimarySpecList.Off.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.PrimarySpecList.Off.Row[i][8] then
						primaryspecflag = true
						weaponinoffprimary = true
					end
				until (itemID == self.db.char.PrimarySpecList.Off.Row[i][8] or i == #self.db.char.PrimarySpecList.Off.Row)
			end
		end
		if itemEquipLocation == "" or itemEquipLocation == "INVTYPE_BAG" or itemEquipLocation == "INVTYPE_TABARD" or itemEquipLocation == "INVTYPE_BODY" then --Primary Spec "Other" Tab
			if self.db.char.PrimarySpecList.Other.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.PrimarySpecList.Other.Row[i][8] then
						primaryspecflag = true
						otherflag = true
					end
				until (itemID == self.db.char.PrimarySpecList.Other.Row[i][8] or i == #self.db.char.PrimarySpecList.Other.Row)
			end
		end
	end
	if GetNumSpecGroups("player") > 1 then --If the player has 2 talent specs, search through the secondary spec list
		if englishClass == "WARRIOR" and itemEquipLocation == "INVTYPE_2HWEAPON" then
			if self.db.char.SecondarySpecList.Main.Count > 1 then
					local i = 0
					repeat
						i = i + 1
						if itemID == self.db.char.SecondarySpecList.Main.Row[i][8] then
							secondaryspecflag = true
							weaponinmainsecondary = true
						end
					until (itemID == self.db.char.SecondarySpecList.Main.Row[i][8] or i == #self.db.char.SecondarySpecList.Main.Row)
				end
				if self.db.char.SecondarySpecList.Off.Count > 1 then
					local i = 0
					repeat
						i = i + 1
						if itemID == self.db.char.SecondarySpecList.Off.Row[i][8] then
							secondaryspecflag = true
							weaponinoffsecondary = true
						end
					until (itemID == self.db.char.SecondarySpecList.Off.Row[i][8] or i == #self.db.char.SecondarySpecList.Off.Row)
				end
		else
			for i = 1, #self.db.Constants.EquipLocationNumbers, 1 do --Secondary Spec Equippable Items Except INVTYPE_WEAPON, INVTYPE_BAG, INVTYPE_TABARD, and INVTYPE_BODY
				if itemEquipLocation == self.db.Constants.EquipLocationNumbers[i][1] then
					if self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Count > 1 then
						local j = 0
						repeat
							j = j + 1
							if itemID == self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] then
								secondaryspecflag = true
							end
						until (itemID == self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] or j == #self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row)
					end
				end
			end
			if itemEquipLocation == "INVTYPE_WEAPON" then --Secondary Spec INVTYPE_WEAPON
				if self.db.char.SecondarySpecList.Main.Count > 1 then
					local i = 0
					repeat
						i = i + 1
						if itemID == self.db.char.SecondarySpecList.Main.Row[i][8] then
							secondaryspecflag = true
							weaponinmainsecondary = true
						end
					until (itemID == self.db.char.SecondarySpecList.Main.Row[i][8] or i == #self.db.char.SecondarySpecList.Main.Row)
				end
				if self.db.char.SecondarySpecList.Off.Count > 1 then
					local i = 0
					repeat
						i = i + 1
						if itemID == self.db.char.SecondarySpecList.Off.Row[i][8] then
							secondaryspecflag = true
							weaponinoffsecondary = true
						end
					until (itemID == self.db.char.SecondarySpecList.Off.Row[i][8] or i == #self.db.char.SecondarySpecList.Off.Row)
				end
			end
			if itemEquipLocation == "" or itemEquipLocation == "INVTYPE_BAG" or itemEquipLocation == "INVTYPE_TABARD" or itemEquipLocation == "INVTYPE_BODY" then --Secondary Spec "Other" Tab
				if self.db.char.SecondarySpecList.Other.Count > 1 then
					local i = 0
					repeat
						i = i + 1
						if itemID == self.db.char.SecondarySpecList.Other.Row[i][8] then
							secondaryspecflag = true
							otherflag = true
						end
					until (itemID == self.db.char.SecondarySpecList.Other.Row[i][8] or i == #self.db.char.SecondarySpecList.Other.Row)
				end
			end
		end
	end
	
	local primaryspecflag_orig = primaryspecflag
	local secondaryspecflag_orig = secondaryspecflag
	
	--Change flags to user's settings if item is in both spec lists
	if primaryspecflag == true and secondaryspecflag == true then --if item was in both primary & secondary spec lists
		if attainability == "potential" then
			if self.db.profile.potentialspec.choice == 1 then
				primaryspecflag = true
				secondaryspecflag = false
			elseif self.db.profile.potentialspec.choice == 2 then
				primaryspecflag = false
				secondaryspecflag = true
			end
		elseif attainability == "acquired" then
			if self.db.profile.acquiredspec.choice == 1 then
				primaryspecflag = true
				secondaryspecflag = false
			elseif self.db.profile.acquiredspec.choice == 2 then
				primaryspecflag = false
				secondaryspecflag = true
			end
		end
	end
	
	--Now to announce the item
	if attainability == "potential" then
		if primaryspecflag == true and secondaryspecflag == false then
			if self.db.profile.messages.potential then
				if self.db.profile.messages.potentiallocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Upgrade Detected for Primary Spec: "] .. itemLink)
				elseif self.db.profile.messages.potentiallocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Upgrade Detected for Primary Spec: "] .. itemLink)
				end
			end
			if self.db.profile.sound.potential then
				PlaySoundFile(LSM:Fetch("sound", self.db.profile.sound.potentialchoice))
			end
		elseif secondaryspecflag == true and primaryspecflag == false then
			if self.db.profile.messages.potential then
				if self.db.profile.messages.potentiallocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Upgrade Detected for Secondary Spec: "] .. itemLink)
				elseif self.db.profile.messages.potentiallocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Upgrade Detected for Secondary Spec: "] .. itemLink)
				end
			end
			if self.db.profile.sound.potential then
				PlaySoundFile(LSM:Fetch("sound", self.db.profile.sound.potentialchoice))
			end
		end
	elseif attainability == "acquired" then
		if primaryspecflag == true and secondaryspecflag == false then
			if self.db.profile.messages.acquired then
				if self.db.profile.messages.acquiredlocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Upgrade Acquired for Primary Spec: "] .. itemLink)
				elseif self.db.profile.messages.acquiredlocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Upgrade Acquired for Primary Spec: "] .. itemLink)
				end
			end
			if self.db.profile.sound.acquired then
				PlaySoundFile(LSM:Fetch("sound", self.db.profile.sound.acquiredchoice))
			end
		elseif secondaryspecflag == true and primaryspecflag == false then
			if self.db.profile.messages.acquired then
				if self.db.profile.messages.acquiredlocation == "chatwindow" then
					UpgradeList:ChatFrameMessage(L["Upgrade Acquired for Secondary Spec: "] .. itemLink)
				elseif self.db.profile.messages.acquiredlocation == "scrollwindow" then
					UpgradeList:ScrollingWindowMessage(L["Upgrade Acquired for Secondary Spec: "] .. itemLink)
				end
			end
			if self.db.profile.sound.acquired then
				PlaySoundFile(LSM:Fetch("sound", self.db.profile.sound.acquiredchoice))
			end
		end
	end
	
	if otherflag == false and attainability == "acquired" and (primaryspecflag == true or secondaryspecflag == true) then --if item was not in "Other" tab ("Other" tab does not auto-delete) and was acquired
		if self.db.profile.autodelete.enable then
			if itemEquipLocation ~= "INVTYPE_FINGER" and itemEquipLocation ~= "INVTYPE_TRINKET" or (itemEquipLocation == "INVTYPE_FINGER" and self.db.profile.ignoreflags.rings == false) or (itemEquipLocation == "INVTYPE_TRINKET" and self.db.profile.ignoreflags.trinkets == false) then --if the acquired item is not a ring or trinket, or if it was a ring and the ignore rings checkbox is unchecked, or if it was a trinket and the ignore trinkets checkbox is unchecked
				UpgradeList:AutoDelete(itemID, itemEquipLocation, primaryspecflag, secondaryspecflag, weaponinmainprimary, weaponinoffprimary, weaponinmainsecondary, weaponinoffsecondary)
			elseif itemEquipLocation == "INVTYPE_FINGER" and self.db.profile.ignoreflags.rings == true then
				local _, itemLink = GetItemInfo(itemID)
				UpgradeList:ChatFrameMessage("" .. itemLink .. L[" acquired, remember to manually update your Ring list!"])
			elseif itemEquipLocation == "INVTYPE_TRINKET" and self.db.profile.ignoreflags.trinkets == true then
				local _, itemLink = GetItemInfo(itemID)
				UpgradeList:ChatFrameMessage("" .. itemLink .. L[" acquired, remember to manually update your Trinket list!"])
			end
		end
	elseif otherflag == true and attainability == "acquired" then
		local _, itemLink = GetItemInfo(itemID)
		UpgradeList:ChatFrameMessage("" .. itemLink .. L[" acquired, remember to manually update your Other list!"])
	end
end

function UpgradeList:ToggleOptions()
	if self.db.UI.OptionsFrame:IsShown() then
		self.db.UI.OptionsFrame:Hide()
		self.db.profile.mainframe.showoptions = false
	else
		self.db.UI.OptionsFrame:Show()
		self.db.profile.mainframe.showoptions = true
	end
end

function UpgradeList:CHAT_MSG_LOOT(eventName, arg1)
	if string.match(arg1, L['You receive loot: ']) or string.match(arg1, L['You receive item: ']) or string.match(arg1, L['You create: ']) then
		debugUL("Chat message You receive loot or You receive item or You create detected: ", DEBUGMODE)
		local minitable = { strsplit(" [", arg1) }
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i])
				if DEBUGMODE then print(itemLink) end
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		UpgradeList:Compare(ID, itemEquipLoc, "acquired")
	end
end

function UpgradeList:CHAT_MSG_SYSTEM(eventName, arg1)
	if string.match(arg1, L['Received item:']) or string.match(arg1, L['Received .. of item:']) then
		debugUL("Chat message Received item or Received # of item detected: ", DEBUGMODE)
		UpgradeList:CHAT_MSG_LOOT(self, arg1)
		local minitable = { strsplit(" [", arg1) }
		local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice
		for i = 1, #minitable, 1 do
			if string.sub(minitable[i], 1, 1) == "|" then --In minitable, if the first character of a variable is a "|" symbol, that is the item string, so use that entry of minitable to get the itemEquipLoc
				itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(minitable[i])
				if DEBUGMODE then print(itemLink) end
			end
		end
		local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
		UpgradeList:Compare(ID, itemEquipLoc, "acquired")	
	end
end

function UpgradeList:LOOT_OPENED()
	debugUL("Loot window opened: ", DEBUGMODE)
	for index = 1, GetNumLootItems() do
		if (LootSlotIsItem(index)) then
			local itemLink = GetLootSlotLink(index)
			if DEBUGMODE then print(itemLink) end
			local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
			local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
			UpgradeList:Compare(ID, itemEquipLoc, "potential")
		end
	end
end

function UpgradeList:START_LOOT_ROLL(eventName, arg1, arg2) --This and Loot Opened fire when looting something in a group, figure out how to only have Loot Opened fire when opening loot.
	debugUL("Item being rolled on: ", DEBUGMODE)
	local itemLink = GetLootRollItemLink(arg1)
	if DEBUGMODE then print(itemLink) end
	local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
	UpgradeList:Compare(ID, itemEquipLoc, "potential")
end

function UpgradeList:PLAYER_ENTERING_WORLD()
	--[[
	local inInstance, instanceType = IsInInstance()
	if inInstance == 1 and (instanceType == "party" or instanceType == "raid") then --if you're in an instance
		local instanceflag = true
		local name, instancetype, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty, isDynamic = GetInstanceInfo()
		if instanceType == "party" and difficultyIndex == 1 then --Normal 5 mans
			UpgradeList:RefreshWindow(name, "Normal", instanceflag)
		elseif instanceType == "party" and difficultyIndex == 2 then --Heroic 5 mans
			UpgradeList:RefreshWindow(name, "Heoric", instanceflag)
		elseif instanceType == "raid" and (difficultyIndex == 1 or difficultyIndex == 2) then --10/25 man Normal raids
			UpgradeList:RefreshWindow(name, "Normal", instanceflag)
		elseif instanceType == "raid" and (difficultyIndex == 3 or difficultyIndex == 4) then --10/25 man Heroic raids
			UpgradeList:RefreshWindow(name, "Heroic", instanceflag)
		end
	end
	--]]
end

function UpgradeList:ScanQuestItems()
	local num = GetNumQuestChoices()
	if num > 0 then
		for i = 1, num, 1 do
			local itemLink = GetQuestItemLink("choice", i)
			if itemLink == nil then
				print("UpgradeList: Error occurred while scanning quest items.")
			else
				debugUL("Item award detected from quest:", DEBUGMODE)
				if DEBUGMODE then print(itemLink) end
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				local _, _, _, _, _, _, _, _, itemEquipLoc, _, _ = GetItemInfo(itemLink)
				UpgradeList:Compare(ID, itemEquipLoc, "potential")
			end
		end
	end
end

function UpgradeList:QUEST_DETAIL()
	UpgradeList:ScheduleTimer("ScanQuestItems", 0.5)
end

function UpgradeList:QUEST_COMPLETE()
	UpgradeList:ScheduleTimer("ScanQuestItems", 0.5)
end

function UpgradeList:CHAT_MSG_RAID(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			debugUL("Master looter chat msg in raid:", DEBUGMODE)
			local _, itemLink, _, _, _, _, _, _, itemEquipLoc, _, _ = GetItemInfo(arg2)
			if itemLink then
				debugUL("Master looter has linked an item in raid chat:", DEBUGMODE)
				if DEBUGMODE then print(itemLink) end
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				UpgradeList:Compare(ID, itemEquipLoc, "potential")
			end
		end
	end
end

function UpgradeList:CHAT_MSG_RAID_LEADER(arg1, arg2, arg3)
	UpgradeList:CHAT_MSG_RAID(arg1, arg2, arg3)
end

function UpgradeList:CHAT_MSG_RAID_WARNING(arg1, arg2, arg3)
	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
	if lootmethod == "master" and UnitInRaid("player") then
		local name = GetRaidRosterInfo(masterlooterRaidID)
		if arg3 == name and name ~= UnitName("player") then
			debugUL("Master looter raid warning:", DEBUGMODE)
			local _, itemLink, _, _, _, _, _, _, itemEquipLoc, _, _ = GetItemInfo(arg2)
			if itemLink then
				debugUL("Master looter has linked an item in raid warning:", DEBUGMODE)
				if DEBUGMODE then print(itemLink) end
				local _, _, Color, Ltype, ID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				UpgradeList:Compare(ID, itemEquipLoc, "potential")
			end
		end
	end
end

function UpgradeList:ACHIEVEMENT_EARNED(eventName, arg1) --Enables the checkbox and radio button for the secondary spec if the player earns the Duel-Talent specialization achievement.
	if arg1 == 2716 then
		debugUL("Dual-spec achievement event registered", DEBUGMODE)
		self.db.char.SavedOptions.SecondaryCheck:Enable()
		self.db.UI.SecondarySpecRadioButton:Enable()
	end
end

function UpgradeList:ChatEdit_InsertLink(lnk) --Called when a player shift-clicks an item, if the ItemEntryBox has focus, it will add the item's link to the box.
	if self.db.UI.ItemEntryBox:HasFocus() then
		self.db.UI.ItemEntryBox:SetText(lnk)
	end
end

function UpgradeList:ShowTooltip(tooltip)
	local _, itemLink = tooltip:GetItem()
	if not itemLink then
		return
	end
	local _, _, _, _, _, _, itemSubType, _, itemEquipLoc = GetItemInfo(itemLink)
	local _, _, _, _, itemID = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	local _, englishClass = UnitClass("player")
	local primaryspecflag = false
	local secondaryspecflag = false
	local note = ""
	if UpgradeList:ItemCanBeWorn(itemSubType, englishClass) then
		if itemEquipLoc == "INVTYPE_WEAPON" or itemEquipLoc == "INVTYPE_2HWEAPON" then
			if self.db.char.PrimarySpecList.Main.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.PrimarySpecList.Main.Row[i][8] then
						primaryspecflag = true
						note = self.db.char.PrimarySpecList.Main.Row[i][7]
					end
				until (itemID == self.db.char.PrimarySpecList.Main.Row[i][8] or i == #self.db.char.PrimarySpecList.Main.Row)
			end
			if self.db.char.PrimarySpecList.Off.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.PrimarySpecList.Off.Row[i][8] then
						primaryspecflag = true
						note = self.db.char.PrimarySpecList.Off.Row[i][7]
					end
				until (itemID == self.db.char.PrimarySpecList.Off.Row[i][8] or i == #self.db.char.PrimarySpecList.Off.Row)
			end
			if self.db.char.SecondarySpecList.Main.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.SecondarySpecList.Main.Row[i][8] then
						secondaryspecflag = true
						note = self.db.char.SecondarySpecList.Main.Row[i][7]
					end
				until (itemID == self.db.char.SecondarySpecList.Main.Row[i][8] or i == #self.db.char.SecondarySpecList.Main.Row)
			end
			if self.db.char.SecondarySpecList.Off.Count > 1 then
				local i = 0
				repeat
					i = i + 1
					if itemID == self.db.char.SecondarySpecList.Off.Row[i][8] then
						secondaryspecflag = true
						note = self.db.char.SecondarySpecList.Off.Row[i][7]
					end
				until (itemID == self.db.char.SecondarySpecList.Off.Row[i][8] or i == #self.db.char.SecondarySpecList.Off.Row)
			end
		else
			for i = 1, #self.db.Constants.EquipLocationNumbers, 1 do
				if itemEquipLoc == self.db.Constants.EquipLocationNumbers[i][1] then
					if self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Count > 1 then
						local j = 0
						repeat
							j = j + 1
							if itemID == self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] then
								primaryspecflag = true
								note = self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][7]
							end
						until (itemID == self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] or j == #self.db.char.PrimarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row)
					end
					if self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Count > 1 then
						local j = 0
						repeat
							j = j + 1
							if itemID == self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] then
								secondaryspecflag = true
								note = self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][7]
							end
						until (itemID == self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row[j][8] or j == #self.db.char.SecondarySpecList[self.db.Constants.EquipLocationNumbers[i][3]].Row)
					end
				end
			end
		end
	else
		if self.db.char.PrimarySpecList.Other.Count > 1 then
			local i = 0
			repeat
				i = i + 1
				if itemID == self.db.char.PrimarySpecList.Other.Row[i][8] then
					primaryspecflag = true
					note = self.db.char.PrimarySpecList.Other.Row[i][7]
				end
			until (itemID == self.db.char.PrimarySpecList.Other.Row[i][8] or i == #self.db.char.PrimarySpecList.Other.Row)
		end
		if self.db.char.SecondarySpecList.Other.Count > 1 then
			local i = 0
			repeat
				i = i + 1
				if itemID == self.db.char.SecondarySpecList.Other.Row[i][8] then
					secondaryspecflag = true
					note = self.db.char.SecondarySpecList.Other.Row[i][7]
				end
			until (itemID == self.db.char.SecondarySpecList.Other.Row[i][8] or i == #self.db.char.SecondarySpecList.Other.Row)
		end
	end
	
	--Now to update the tooltip
	if primaryspecflag and secondaryspecflag then --in both primary & secondary spec lists
		tooltip:AddLine("Upgrade for Primary Spec & Secondary Spec", 0, 1, 0, 1)
		tooltip:AddTexture("Interface\\Icons\\Achievement_BG_returnXflags_def_WSG")
	elseif primaryspecflag then --only in primary spec list
		tooltip:AddLine("Upgrade for Primary Spec", 0, 1, 0, 1)
		tooltip:AddTexture("Interface\\Icons\\Achievement_BG_returnXflags_def_WSG")
	elseif secondaryspecflag then --only in secondary spec list
		tooltip:AddLine("Upgrade for Secondary Spec", 0, 1, 0, 1)
		tooltip:AddTexture("Interface\\Icons\\Achievement_BG_returnXflags_def_WSG")
	end
	if (primaryspecflag or secondaryspecflag) and note ~= "" then
		tooltip:AddLine("       " .. note, 1, 1, 1, 1)
	end
	tooltip:Show()
end

function UpgradeList:ScanDatabase()
	local searchResults = {}
	local Spec = _G["PRIMARY"]
	local SpecLong = "PrimarySpecList"
	for h = 1, GetNumSpecGroups(), 1 do
		if h == 2 then
			Spec = _G["SECONDARY"]
			SpecLong = "SecondarySpecList"
		end
		for i = 1, self.db.UI.MainFrame.numTabs, 1 do
			if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Count > 1 then
				local j = 0
				repeat
					j = j + 1
					local matchFlag = false
					for k = 1, #self.db.Raids, 1 do
						if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == self.db.Raids[k][1] then
							matchFlag = self.db.UI.TrackFrame.checkButtons[1]:GetName()
						end
					end
					for k = 1, #self.db.Dungeons, 1 do
						if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == self.db.Dungeons[k][1] then
							matchFlag = self.db.UI.TrackFrame.checkButtons[2]:GetName()
						end
					end
					if not matchFlag then
						for k = 1, #self.db.Constants.Professions, 1 do
							if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == self.db.Constants.Professions[k] then
								matchFlag = self.db.UI.TrackFrame.checkButtons[3]:GetName()
							end
						end
					end
					if not matchFlag then
						if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == _G["QUESTS_LABEL"] then
							matchFlag = self.db.UI.TrackFrame.checkButtons[4]:GetName()
						end
					end
					if not matchFlag then
						for k = 1, #self.db.Constants.Reputations, 1 do
							if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == self.db.Constants.Reputations[k] then
								matchFlag = self.db.UI.TrackFrame.checkButtons[5]:GetName()
							end
						end
					end
					if not matchFlag then
						for k = 1, #self.db.Constants.Currency, 1 do
							if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == self.db.Constants.Currency[k] then
								matchFlag = self.db.UI.TrackFrame.checkButtons[6]:GetName()
							end
						end
					end
					if not matchFlag then
						if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5] == _G["CHANNEL_CATEGORY_WORLD"] then
							matchFlag = self.db.UI.TrackFrame.checkButtons[7]:GetName()
						end
					end
					if not matchFlag then
						matchFlag = self.db.UI.TrackFrame.checkButtons[8]:GetName()
					end
					
					for k = 1, #self.db.UI.TrackFrame.checkButtons, 1 do
						if self.db.UI.TrackFrame.checkButtons[k]:GetName() == matchFlag and self.db.UI.TrackFrame.checkButtons[k]:GetChecked() then
							if self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][4] == nil then self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][4] = "" end
							table.insert(searchResults, {Spec, self.db.Constants.TabNames[i][3], self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][3], self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][4], self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][5], self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Row[j][6]})
						end
					end
				until (j == self.db.char[SpecLong][self.db.Constants.TabNames[i][2]].Count - 1)
			end
		end
	end
	return searchResults
end

function UpgradeList:DrawTestWindow()
	f = CreateFrame("Frame","F",UIParent)
	f:SetFrameStrata("BACKGROUND")
	f:SetWidth(500)
	f:SetHeight(500)

	f:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
			edgeFile = "Interface/DialogFrame/UI-DialogBox-Border",
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 11, right = 11, top = 10, bottom = 10 }})

	f:SetBackdropColor(0,0,0,0.8)

	f:SetPoint("CENTER",0,0)
	
	--Scroll Frame
	f.sc = CreateFrame("ScrollFrame","SC",f)
	f.sc:SetPoint("TOP", 0, -13)
	f.sc:SetPoint("BOTTOM", 0, 12)
	f.sc:SetPoint("LEFT", 15, 0)
	f.sc:SetPoint("RIGHT", -35, 0)
	f.sc.t = f.sc:CreateTexture()
	f.sc.t:SetAllPoints(f.sc)
	f.sc.t:SetTexture(0,1,0,0.5)
	
	--Slider
	f.sl = CreateFrame("Slider","SL",f.sc,"UIPanelScrollBarTemplate")
	f.sl:SetPoint("TOPLEFT", f.sc, "TOPRIGHT", 5, -15)
	f.sl:SetPoint("BOTTOMLEFT", f.sc, "BOTTOMRIGHT", 5, 15)
	f.sl:SetPoint("LEFT", f.sc, "RIGHT", 0, 0)
	f.sl.scrollStep = 1
	f.sl:SetWidth(16)
	f.sl:SetMinMaxValues(0, 1000)
	f.sl:SetOrientation("VERTICAL")
	f.sl:SetValue(0)
	f.sl:SetValueStep(1)
	f.sl:SetScript("OnValueChanged", function(self,value)
		self:GetParent():SetVerticalScroll(value)
	end)
	f.sl.bg = f.sl:CreateTexture(nil,"BACKGROUND")
	f.sl.bg:SetAllPoints(f.sl)
	f.sl.bg:SetTexture(0.2,0.2,0.2,0.8)
	
	
	--EditBox
	f.eb = CreateFrame("EditBox","EB",f.sc)
	f.eb:SetPoint("TOPLEFT", 5, -5)
	f.eb:SetWidth(f.sc:GetWidth())
	f.eb:SetFontObject(ChatFontNormal)
	f.eb:SetMultiLine(true)
	f.eb.t = f.eb:CreateTexture()
	f.eb.t:SetAllPoints(f.eb)
	f.eb.t:SetTexture(1,0,0,0.5)
	
	
	f.sc:SetScrollChild(f.eb)
	
	f:Show()
end

function UpgradeList:OnEnable()
	--Register for Events
	UpgradeList:RegisterEvent("CHAT_MSG_LOOT")
	UpgradeList:RegisterEvent("CHAT_MSG_SYSTEM")
	UpgradeList:RegisterEvent("LOOT_OPENED")
	UpgradeList:RegisterEvent("START_LOOT_ROLL")
	UpgradeList:RegisterEvent("PLAYER_ENTERING_WORLD")
	UpgradeList:RegisterEvent("QUEST_DETAIL")
	UpgradeList:RegisterEvent("QUEST_COMPLETE")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID_LEADER")
	UpgradeList:RegisterEvent("CHAT_MSG_RAID_WARNING")
	if GetNumSpecGroups("player") == 1 then
		UpgradeList:RegisterEvent("ACHIEVEMENT_EARNED")
	end
	
	--Hooks
	UpgradeList:SecureHook("ChatEdit_InsertLink") --Happens when a player shift-clicks an item
	UpgradeList:HookScript(GameTooltip, "OnTooltipSetItem", "ShowTooltip")
	UpgradeList:HookScript(ItemRefTooltip, "OnTooltipSetItem", "ShowTooltip")
	
	--UpgradeList:DrawTestWindow()
	UpgradeList:LoadConstants()
	UpgradeList:DrawUI()
	
end